"use strict";
function merge(target, source) {
    if (source) {
        for (const [key, value2] of Object.entries(source)) {
            if (value2 !== undefined) {
                const value1 = target[key];
                if (value1 === undefined) {
                    target[key] = value2;
                }
                else if (Array.isArray(value1) && Array.isArray(value2)) {
                    target[key] = value1.concat(value2);
                }
                else if (isObject(value1) && isObject(value2)) {
                    target[key] = merge(value1, value2);
                }
                else {
                    target[key] = value2;
                }
            }
        }
    }
    return target;
}
function isObject(value) {
    return value instanceof Object && value.constructor === Object;
}
module.exports = function mergeObjects(...objects) {
    return objects.reduce(merge, {});
};
//# sourceMappingURL=index.js.map